program CALCULATOR;

{$A+,B-,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V-,X-}
{$M 8192,0,655360}

const Digits: set of char = ['0'..'9'];
      AddSet: set of char = ['+', '-'];
      MulSet: set of char = ['*', '/', '%', '<', '>', '&', ':'];

var Inp:string;
    I: word;
    Acc: longint;

procedure Help;
begin
  writeln('Syntaxe: kalkul AritmetickyVyraz');
  Halt(1);
end;

procedure ErrMess (Mess: String);
begin
  writeln(' Error: '+Mess);
  Halt(1);
end;

function C(op1,op2:longint; op:char): longint;
var P:longint;
begin
  case op of
    '+': P:=op1+op2;
    '-': P:=op1-op2;
    '*': P:=op1*op2;
    '/': if op2=0 then ErrMess('Deleni nulou')
         else P:=op1 div op2;
    '%': if op2=0 then ErrMess('Deleni nulou')
         else P:=op1 mod op2;
    '>': P:=op1 shr op2;
    '<': P:=op1 shl op2;
    '&': P:=op1 and op2;
    ':': P:=op1 or op2;
    end;
  C:=P;
end;

procedure Expression; forward;

procedure Factor;
var Count: byte;
begin
  if (Inp[I] in Digits) then begin
    Acc:=0; Count:=0;
    repeat
      Acc:=10*Acc+(ord(Inp[I])-ord('0'));
      Inc(I);
      Inc (Count);
      if (Count =10) then ErrMess('Prilis velke cislo');
    until not (Inp[I] in Digits)
    end
  else if Inp[I] = '(' then begin
    Inc(I);
    Expression;
    if Inp[I] = ')' then Inc(I)
    else ErrMess('Chyba ")"');
    end
  else ErrMess('Nespravny aritmeticky vyraz');
end;

procedure Term;
var MulOp: char;
    P:longint;
begin
  Factor;
  while Inp[I] in MulSet do begin
    MulOp:=Inp[I];
    P:=Acc;
    Inc(I);
    Factor;
    Acc:= C(P,Acc,MulOp)
  end
end;

procedure Expression;
var AddOp: char;
    P:longint;
begin
  if Inp[I] in AddSet then begin
    AddOp:=Inp[I];
    Inc(I);
    Term;
    if AddOp ='-' then Acc:= -Acc;
    end
  else term;

  while Inp[I] in AddSet do begin
    AddOp:=Inp[I];
    P:=Acc;
    Inc(I);
    Term;
    Acc:= C(P,Acc,AddOp)
    end;
end;

begin
  if ParamCount < 1 then Help;
  if ParamStr(1) ='/?' then Help;
  Inp:='';
  for i:=1 to ParamCount do
    Inp:=Inp+ParamStr(I);
  Inp[Length(Inp)+1]:='#';
  I:=1;
  Expression;
  if Inp[I] = '#' then writeln('  ',Acc)
  else ErrMess('Nespravny aritmeticky vyraz');
end.